<?php
/**
* @package RSComments!
* @copyright (C) 2014 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined('_JEXEC') or die('Restricted access');

class RSCommentsViewComments extends JViewLegacy
{
	protected $comments;
	protected $filterbar;
	protected $pagination;

	public function display($tpl = null) {
		// Add custom scripts
		$this->addScripts();

		$this->items 		= $this->get('Items');
		$this->pagination 	= $this->get('Pagination');
		$this->state 		= $this->get('State');
		$this->article		= RSCommentsHelper::ArticleTitle($this->state->get('com_rscomments.comments.filter.component'), $this->state->get('com_rscomments.comments.filter.component_id'));

		$this->addToolbar();

		$this->filterbar	= $this->get('FilterBar');
		$this->sidebar 		= $this->get('SideBar');

		parent::display($tpl);
	}

	protected function addToolbar() {
		JToolBarHelper::title(JText::sprintf('COM_RSCOMMENTS_COMMENTS_TITLE', (!empty($this->article) ? JText::_('COM_RSCOMMENTS_FROM').$this->article : '')),'rscomment');

		// add Menu in sidebar
		require_once JPATH_COMPONENT.'/helpers/toolbar.php';
		RSCommentsToolbarHelper::addToolbar('comments');

		JToolBarHelper::editList('comment.edit');
		JToolbarHelper::publish('comments.publish', 'JTOOLBAR_PUBLISH', true);
		JToolbarHelper::unpublish('comments.unpublish', 'JTOOLBAR_UNPUBLISH', true);
		JToolBarHelper::deleteList('','comments.delete');
		JToolBarHelper::custom('comments.votes','trash','trash',JText::_('COM_RSCOMMENTS_CLEAR_VOTES'));
		JToolBarHelper::preferences('com_rscomments');
	}

	protected function addScripts() {
		if (!RSCommentsHelper::isJ3()) {
			JFactory::getDocument()->addScript('components/com_rscomments/assets/js/jquery-1.11.1.min.js');
			JFactory::getDocument()->addScript('components/com_rscomments/assets/js/jquery.noConflict.js');
		}
	}
}