<?php
/**
* @package		EasyBlog
* @copyright	Copyright (C) 2010 Stack Ideas Private Limited. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* EasyBlog is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/
defined('_JEXEC') or die('Restricted access');

class getRSCommentsTab extends cbTabHandler
{
	public $user	= null;
	
	public function getRSCommentsTab() {
		return $this->cbTabHandler();
	}
	
	public function getDisplayTab($tab, $user, $ui) {
		if(file_exists(JPATH_SITE.'/components/com_rscomments/rscomments.php')) {
			require_once JPATH_SITE.'/components/com_rscomments/helpers/rscomments.php';

			$db			= JFactory::getDBO();
			$document 	= JFactory::getDocument();
			$my_user	= JFactory::getUser();
			JFactory::getLanguage()->load('com_rscomments', JPATH_SITE);

			$i						= 0;
			$params			 		= $this->params;
			$total_comments 		= RSCommentsHelper::getTotalCBUserComments($user->id);
			$rsc_comments_per_page 	= $params->get('rsc_comments_per_page',10);
			$rsc_comment_length		= $params->get('rsc_comment_length',90);
			$user_comments			= RSCommentsHelper::getCBUserComments($user->id, 0, $rsc_comments_per_page);

			// if the user looks at his own profile page
			if($user->id == $my_user->id) 
				$user->name = JText::_('COM_RSCOMMENTS_YOU');

			$document->addStyleSheet(JURI::root(true).'/components/com_comprofiler/plugin/user/plug_rscommentstab/style.css');
			$document->addScriptDeclaration("
					function rsc_load_more()
					{
						var start_limit 	= document.getElementsByClassName('rsc_cb_comments_box').length;
						var total_comments	= ".$total_comments.";
						
						var req = new Request({
							method: 'post',
							url: 'index.php?option=com_rscomments',
							data: 'task=comments.cbcomments&userid=".$user->id."' + '&start=' + start_limit + '&limit=".$rsc_comments_per_page."&randomTime='+Math.random(),
							onSuccess: function(responseText, responseXML) {
								response = responseText;
								var comments =  JSON.parse(response);

								for(i=0;i < comments.length; i++) {
									var new_comment = document.createElement('p');
									new_comment.className = 'rsc_cb_comments_box';
									new_comment.innerHTML = '".$user->name." ".JText::_("COM_RSCOMMENTS_WROTE")." <a href=\"'+comments[i].url+'\">'+comments[i].comment.substr(0,".$rsc_comment_length.")+'</a>...';
									document.getElementById('rsc_cb_comments_container').appendChild(new_comment);
								}

								var comments_displayed = document.getElementsByClassName('rsc_cb_comments_box').length;
								if(comments_displayed >= total_comments) document.getElementById('rsc_load_more').style.display = 'none';
							}
						});
						req.send();
					};");

			$html = '<div id="rsc_cb_comments_container">';
			if (!empty($user_comments)) {
				foreach($user_comments as $comment) {
					$html .= '<span class="rsc_cb_comments_box"> '.$user->name.' '.JText::_('COM_RSCOMMENTS_WROTE').' "<a href="'.$comment->url.'">'.substr($comment->comment,0,$rsc_comment_length).' ...</a>"</span>';
					$i++;
				}
			}

			$html .= '<div class="rsc_cb_clear"></div>';
			$html .= '</div>';
			
			if($total_comments > $i)
				$html .= '<div class="rsc_load_more_class"><a href="javascript:void(0);" onclick="rsc_load_more();" id="rsc_load_more" class="btn btn-info button">'.JText::_ ('COM_RSCOMMENTS_LOAD_MORE_COMMENTS').'</a></div>';
				
			$html .= '<div class="rsc_cb_clear" ></div>';
		} else $html = '<p>'.JText::_('COM_RSCOMMENTS_ERROR_CB_TAB_NO_RSCOMMENTS').'</p>';
		return $html;
	}
}