<?php
/**
* @version 1.0.0
* @package RSComments! 1.0.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin');

class plgContentRSComments extends JPlugin
{
	public function plgContentRSComments(&$subject, $config) {
		parent::__construct($subject, $config);
	}

	public function onContentAfterDisplay($context, &$article, &$params, $limitstart=0) {
		
		if ($context == 'mod_articles_news.content') {
			return;
		}
		
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);
		$app	= JFactory::getApplication();
		$input	= $app->input;
		
		if ($app->getName() != 'site') {
			return;
		}
		
		// check if RSComments! is installed
		if (!$this->canRun()) {
			return;
		}
		
		//load the language
		JFactory::getLanguage()->load('com_rscomments');
		
		$config = RSCommentsHelper::getConfig();
		$option = $input->getCmd('option');
		$view	= $input->getCmd('view');
		
		//Plugin only for com_content
		if($option != 'com_content')
			return false;
		
		if (!isset($article->id)) {
			RSCommentsHelper::clean($article); 
			return; 
		}
		
		$query->clear()
			->select('CONCAT('.$db->qn('introtext').','.$db->qn('fulltext').')')
			->from($db->qn('#__content'))
			->where($db->qn('id').' = '.(int) $article->id);
		
		$db->setQuery($query);
		$content = $db->loadResult();
		
		$this->_on  = RSCommentsHelper::rscOn($content);
		$this->_off = RSCommentsHelper::rscOff($content);
		
		if ($view == 'frontpage' || $view == 'category' || $view == 'section' || $view == 'featured' || $option != 'com_content')  {
			RSCommentsHelper::clean($article); 
			if (isset($config->categories)) {
				if ($categories = $config->categories) {
					if(in_array($article->catid,$categories) && !$this->_on) {
						return;
					}
				}
			}
			
			if ($this->_off) {
				RSCommentsHelper::clean($article);
				return;
			}
			
			$comments = RSCommentsHelper::getCommentsNumber($article->id,true);
			$text = empty($comments) ? JText::_('COM_RSCOMMENTS_NO_COMMENTS') : JText::sprintf('COM_RSCOMMENTS_COMMENTS_NUMBER',$comments);
			$show_no_comments = $config->show_no_comments;
			
			$image = '<img src="'.JURI::root().'components/com_rscomments/assets/images/comments.png" alt="" width="16" height="16" />';
			
			if (empty($comments)) {
				if ($show_no_comments) {
					$article->introtext = $article->introtext.'<div class="rsc_comments_count">'.$image.' <a href="'.JRoute::_(ContentHelperRoute::getArticleRoute(!empty($article->slug) ? $article->slug : $article->id, !empty($article->catslug) ? $article->catslug : $article->catid)).'">'.$text.'</a></div>'; 
				}
			} else {
				$article->introtext = $article->introtext.'<div class="rsc_comments_count">'.$image.' <a href="'.JRoute::_(ContentHelperRoute::getArticleRoute(!empty($article->slug) ? $article->slug : $article->id, !empty($article->catslug) ? $article->catslug : $article->catid)).'">'.$text.'</a></div>';
			}
			
			return;
		}
		
		// check whether the plugin has been unpublished
		if (!JPluginHelper::isEnabled('content', 'rscomments')) {
			RSCommentsHelper::clean($article);
			return;
		}
		
		if ($this->_off) {
			RSCommentsHelper::clean($article); 
			$comments_closed = RSCommentsHelper::getMessage('comments_closed');
			$msg = empty($comments_closed) ? '' : '<hr/>'.$comments_closed;
			
			return $msg; 
		}
		
		$this->_template = RSCommentsHelper::getTemplate();
		$this->_articleid = $article->id;
		RSCommentsHelper::clean($article);
		
		//clean the cache
		$cache = JFactory::getCache('com_content');
		$cache->clean();
		$cache = JFactory::getCache('page');
		$cache->clean();
		
		JHtml::_('behavior.framework', true);
		JHtml::_('behavior.modal','.rs_modal');
		
		//load the js and css code
		$doc = JFactory::getDocument();
		$doc->addScriptDeclaration("var rsc_root = '".addslashes(JURI::root())."';");
		$doc->addScriptDeclaration("var rsc_tooltip = '".(RSCommentsHelper::isJ3() ? 'hasTooltip' : 'hasTip')."';");
		$doc->addScript(JURI::root(true).'/components/com_rscomments/assets/js/rscomments.js');
		$doc->addScript(JURI::root(true).'/components/com_rscomments/assets/js/bbcode.js');
		$doc->addStyleSheet(JURI::root(true).'/components/com_rscomments/assets/css/style.css');
		
		return RSCommentsHelper::showRSComments('com_content',$this->_articleid,$this->_template, null, $this->_on);
	}
	
	protected function canRun() {
		if (file_exists( JPATH_SITE.'/administrator/components/com_rscomments/rscomments.php' )) {
			require_once JPATH_SITE.'/components/com_rscomments/helpers/tooltip.php';
			require_once JPATH_SITE.'/components/com_rscomments/helpers/rscomments.php';
			
			return true;
		}
		
		return false;
	}
}