<?php
/**
* @version 1.0.0
* @package RSComments! 1.0.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin');

class plgSystemRSComments extends JPlugin
{
	public function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
	}
	
	protected function canRun() {
		if (JFactory::getApplication()->getName() != 'site')
			return false;
		
		if (JFactory::getApplication()->input->get('view') == 'frontpage' || JFactory::getApplication()->input->get('format') == 'feed')
			return false;
		
		if (file_exists(JPATH_SITE.'/components/com_rscomments/helpers/rscomments.php')) {
			require_once JPATH_SITE.'/components/com_rscomments/helpers/tooltip.php';
			require_once JPATH_SITE.'/components/com_rscomments/helpers/rscomments.php';
			JFactory::getLanguage()->load('com_rscomments',JPATH_SITE);
			return true;
		}
		
		return false;
	}

	public function onAfterDispatch() {
		if (!$this->canRun()) return;
		
		$db			= JFactory::getDBO();
		$app 		= JFactory::getApplication();
		$doc		= JFactory::getDocument();
		$template	= RSCommentsHelper::getTemplate();
		
		JHtml::_('behavior.framework',true);
		JHtml::_('behavior.modal','.rs_modal');
		
		$doc->addScriptDeclaration("var rsc_root = '".addslashes(JURI::root())."';");
		$doc->addScriptDeclaration("var rsc_tooltip = '".(RSCommentsHelper::isJ3() ? 'hasTooltip' : 'hasTip')."';");
		$doc->addScript(JURI::root(true).'/components/com_rscomments/assets/js/rscomments.js');
		$doc->addScript(JURI::root(true).'/components/com_rscomments/assets/js/bbcode.js');
		$doc->addStyleSheet(JURI::root(true).'/components/com_rscomments/assets/css/style.css');
		$doc->addStyleSheet(JURI::root(true).'/components/com_rscomments/assets/css/form.css');
		
		if (RSCommentsHelper::isJ3())
			$doc->addStyleSheet(JURI::root(true).'/components/com_rscomments/assets/css/j3.css');
		else
			$doc->addStyleSheet(JURI::root(true).'/components/com_rscomments/designs/'.$template.'/'.$template.'.css');
		
		RSCommentsHelper::accordion();
	}
	
	public function onAfterRender() {
		if (!$this->canRun()) return;
		
		$pattern 	= '#{rscomments option="(.*?)" id="(.*?)"}#is';
		$body 		= JResponse::getBody();
		
		// Get all ocurrences for : {rscomments option="com_test" id="1"}
		preg_match_all($pattern, $body, $matches);
		
		if (!empty($matches[0])) {
			$placeholder 	= end($matches[0]);
			$option 		= end($matches[1]);
			$id 			= end($matches[2]);
			
			$cache = JFactory::getCache($option);
			$cache->clean();
			$cache = JFactory::getCache('page');
			$cache->clean();
			
			$this->_template = RSCommentsHelper::getTemplate();
			$html = RSCommentsHelper::showRSComments($option,$id,$this->_template);
			$body = str_replace($placeholder,$html,$body);
			
			foreach($matches[0] as $text)
				$body = str_replace($text,'',$body);
		}
		
		$pattern = '#{rscomments_no option="(.*?)" id="(.*?)"}#is';
		preg_match_all($pattern, $body, $matches);
		
		if (!empty($matches[0])) {
			foreach ($matches[0] as $index => $fullmatch) {
				$placeholder 	= $fullmatch;
				$option 		= $matches[1][$index];
				$id 			= $matches[2][$index];
				
				$comments = RSCommentsHelper::getCommentsNumber($id, false, $option);
				$text = empty($comments) ? JText::_('COM_RSCOMMENTS_NO_COMMENTS') : JText::sprintf('COM_RSCOMMENTS_COMMENTS_NUMBER',$comments);
				
				$cache = JFactory::getCache($option);
				$cache->clean();
				$cache = JFactory::getCache('page');
				$cache->clean();
				
				$body = str_replace($fullmatch, $text, $body);
			}
		}
		
		JResponse::setBody($body);
	}
}