﻿/*
 * RSComments! javascript functions
*/

window.addEvent('domready', function() {
	rsc_shuffle();
});

var Shake = new Class({
	Implements:Options,
		options:{
			color: '#C8C8C8',
			distance: 6,
			duration: 50,
			transition: Fx.Transitions.Sine.easeInOut,
			loops: 10
		},
		
	initialize:function(element,options){
		this.setOptions(options);
		this.element=$(element);
		if(this.element.getStyle('position')!='absolute') this.element.setStyle('position','relative');
		this.tween = new Fx.Tween(this.element,{ 
			link: 'chain', 
			duration: this.options.duration,
			transition: this.options.transition
		});
	},
	
	shake:function(){
		var d=this.options.distance;
		for(x=0;x<this.options.loops;x++) this.tween.start('left',d).start('left',-d);
		this.tween.start('left',d).start('left',0);
	},
	
	stop:function() {
		this.tween.stop();
	}
});

var getElementsByClassName = function (className, tag, elm){
	if (document.getElementsByClassName) {
		getElementsByClassName = function (className, tag, elm) {
			elm = elm || document;
			var elements = elm.getElementsByClassName(className),
				nodeName = (tag)? new RegExp("\\b" + tag + "\\b", "i") : null,
				returnElements = [],
				current;
			for(var i=0, il=elements.length; i<il; i+=1){
				current = elements[i];
				if(!nodeName || nodeName.test(current.nodeName)) {
					returnElements.push(current);
				}
			}
			return returnElements;
		};
	}
	else if (document.evaluate) {
		getElementsByClassName = function (className, tag, elm) {
			tag = tag || "*";
			elm = elm || document;
			var classes = className.split(" "),
				classesToCheck = "",
				xhtmlNamespace = "http://www.w3.org/1999/xhtml",
				namespaceResolver = (document.documentElement.namespaceURI === xhtmlNamespace)? xhtmlNamespace : null,
				returnElements = [],
				elements,
				node;
			for(var j=0, jl=classes.length; j<jl; j+=1){
				classesToCheck += "[contains(concat(' ', @class, ' '), ' " + classes[j] + " ')]";
			}
			try	{
				elements = document.evaluate(".//" + tag + classesToCheck, elm, namespaceResolver, 0, null);
			}
			catch (e) {
				elements = document.evaluate(".//" + tag + classesToCheck, elm, null, 0, null);
			}
			while ((node = elements.iterateNext())) {
				returnElements.push(node);
			}
			return returnElements;
		};
	}
	else {
		getElementsByClassName = function (className, tag, elm) {
			tag = tag || "*";
			elm = elm || document;
			var classes = className.split(" "),
				classesToCheck = [],
				elements = (tag === "*" && elm.all)? elm.all : elm.getElementsByTagName(tag),
				current,
				returnElements = [],
				match;
			for(var k=0, kl=classes.length; k<kl; k+=1){
				classesToCheck.push(new RegExp("(^|\\s)" + classes[k] + "(\\s|$)"));
			}
			for(var l=0, ll=elements.length; l<ll; l+=1){
				current = elements[l];
				match = false;
				for(var m=0, ml=classesToCheck.length; m<ml; m+=1){
					match = classesToCheck[m].test(current.className);
					if (!match) {
						break;
					}
				}
				if (match) {
					returnElements.push(current);
				}
			}
			return returnElements;
		};
	}
	return getElementsByClassName(className, tag, elm);
};

function initTooltips() {
	tooltip = typeof rsc_tooltip != 'undefined' ? rsc_tooltip : 'hasTip';
	
	if (tooltip.indexOf('hasTooltip') > -1) {
		jQuery('.hasTooltip').tooltip({"html": true,"container": "body"});
	} else {
		$$('.hasTip').each(function(el) {
			var title = el.get('title');
			if (title) {
				var parts = title.split('::', 2);
				el.store('tip:title', parts[0]);
				el.store('tip:text', parts[1]);
			}
		});
		var JTooltips = new Tips($$('.hasTip'), { maxTitleChars: 50, fixed: false});
	}
}

function rsc_initTooltips(divid,isajaxcall) {
	initTooltips();
}

function rsc_initModal() {
	tooltip = typeof rsc_tooltip != 'undefined' ? rsc_tooltip : 'hasTip';
	
	$$('.rs_modal').each(function (el) {
	  el.removeEvents('click'); 
	});
	
	if (tooltip.indexOf('hasTooltip') > -1) {
		jQuery(function($) {
			SqueezeBox.initialize({});
			SqueezeBox.assign($('.rs_modal').get(), {
				parse: 'rel'
			});
		});
	} else {
		SqueezeBox.initialize({});
		SqueezeBox.assign($$('.rs_modal'), {
			parse: 'rel'
		});
	}
}

function insertAfter(referenceNode, newNode) {
    referenceNode.parentNode.insertBefore(newNode, referenceNode.nextSibling);
}

function rsc_get_ie() {
	var rv = -1; // Return value assumes failure.
	if (navigator.appName == 'Microsoft Internet Explorer') {
		var ua = navigator.userAgent;
		var re  = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
		if (re.exec(ua) != null)
			rv = parseFloat( RegExp.$1 );
	}
	return rv;
}

function rsc_upload(root,url_captcha) {
	//set the id to the upload frame
	var rsframe 	= document.getElementById('rsc_frame');
	var innerDoc 	= rsframe.contentDocument || rsframe.contentDocument.document;

	// setting the functions variables to the frame hidden inputs
	innerDoc.getElementById('root').value 	= root;
	innerDoc.getElementById('url_captcha').value 	= url_captcha;

	innerDoc.getElementById('frameform').submit();
}

function rsc_adopt(container, adopted){
	$$(container).adopt($$(adopted));
}

function isset () {
    var a = arguments,
        l = a.length,
        i = 0,
        undef;

    if (l === 0) {
        throw new Error('Empty isset');
    }

    while (i !== l) {
        if (a[i] === undef || a[i] === null) {
            return false;
        }
        i++;
    }
    return true;
}

function hasClass(ele,cls) {
	return ele.className.match(new RegExp('(\\s|^)'+cls+'(\\s|$)'));
}

function removeClass(ele,cls) {
	if (hasClass(ele,cls)) {
		var reg = new RegExp('(\\s|^)'+cls+'(\\s|$)');
		ele.className=ele.className.replace(reg,' ');
	}
}

function rsc_comment_cnt(field,cntfield,maxlimit) {
	field = document.getElementById(field);	
	if (field.value.length > maxlimit)
		field.value = field.value.substring(0, maxlimit);
	else
		document.getElementById(cntfield).innerHTML = maxlimit - field.value.length;
}

function checkEmail(str) {
	var at="@"
	var dot="."
	var lat=str.indexOf(at)
	var lstr=str.length
	var ldot=str.indexOf(dot)
	if (str.indexOf(at)==-1)
	   return false

	if (str.indexOf(at)==-1 || str.indexOf(at)==0 || str.indexOf(at)==lstr)
	   return false

	if (str.indexOf(dot)==-1 || str.indexOf(dot)==0 || str.indexOf(dot)==lstr)
		return false

	if (str.indexOf(at,(lat+1))!=-1)
		return false

	if (str.substring(lat-1,lat)==dot || str.substring(lat+1,lat+2)==dot)
		return false

	if (str.indexOf(dot,(lat+2))==-1)
		return false

	if (str.indexOf(" ")!=-1)
		return false

	return true					
}

function rsc_show_emoticons(what) {
	var popup = document.getElementById('rsc_emoticons');
	popup.style.display = 'block';
}

function rsc_check(e) {
	var target = (e && e.target) || (event && event.srcElement);
	var obj = document.getElementById('rsc_emoticons');
	var obj2 = document.getElementById('rsc_emoti_on');
	
	if (isset(obj))
		rsc_checkParent(target)?obj.style.display='none':null;
	
	target==obj2?obj.style.display='block':null;
}

function rsc_checkParent(t) {
	while(t.parentNode) {
		if (t == document.getElementById('rsc_emoticons')) return false;
		t=t.parentNode;
	}
	return true
}

function rsc_reply(id) {
	if (!isset(document.getElementById('rscommentsFormContainer')))
		return;
	
	//move de form to the reply 
	$$('#rsc_replyform_container'+id).adopt($$('#rscommentsForm'));
	// clear the form
	document.getElementById('rscommentsForm').reset();
	// set the IdParent
	document.getElementById('rsc_id_parent').value = id;
	// add the cancel button button
	document.getElementById('rsc_cancel').style.display = 'inline';
}

function rsc_cancel_reply() {	
	//move the form from the Add Comment area to the selected thread
	$$('#rscommentsFormContainer').adopt($$('#rscommentsForm'));

	document.getElementById('rsc_id_parent').value = '0';
	document.getElementById('rsc_cancel').style.display = 'none';
	rsc_reset_form();
}

function rtrim (str, charlist) {
    charlist = !charlist ? ' \\s\u00A0' : (charlist + '').replace(/([\[\]\(\)\.\?\/\*\{\}\+\$\^\:])/g, '\\$1');
    var re = new RegExp('[' + charlist + ']+$', 'g');    return (str + '').replace(re, '');
}

// Unsubscribe function
function rsc_unsubscribe(id, option) {
	document.getElementById('rsc_loading_top').style.display = '';
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.unsubscribe&id=' + id + '&opt=' + option + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			document.getElementById('rsc_loading_top').style.display = 'none';
			var response = responseText;
			response = response.split('|');
			document.getElementById('rsc_subscr').innerHTML = response[1];
			alert(response[0]);
			initTooltips();
		}
	});
	req.send();
}

// Subscribe function
function rsc_subscribe(id,option) {	
	document.getElementById('rsc_loading_top').style.display = '';
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.subscribe&id=' + id + '&opt=' + option + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			document.getElementById('rsc_loading_top').style.display = 'none';
			var response = responseText;
			response = response.split('|');
			document.getElementById('rsc_subscr').innerHTML = response[1];
			alert(response[0]);
			initTooltips();
		}
	});
	req.send();
}

// Vote positive for a comment
function rsc_pos(id) {
	var container = document.getElementById('rsc_voting'+id);
	var loader = document.getElementById('rsc_loading_top');
	loader.style.display = '';
	
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.voteup&id=' + id + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			loader.style.display = 'none';
			container.innerHTML = responseText;
			initTooltips();
		}
	});
	req.send();
}

function rsc_neg(id) {
	var container = document.getElementById('rsc_voting'+id);
	var loader = document.getElementById('rsc_loading_top');
	loader.style.display = '';
	
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.votedown&id=' + id + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			loader.style.display = 'none';
			container.innerHTML = responseText;
			initTooltips();
		}
	});
	req.send();
}

function rsc_quote(name,id) {
	if (!isset(document.getElementById('rscommentsFormContainer')))
		return;
	
	var loader = document.getElementById('rsc_loading_form');
	loader.style.display = '';
	
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.quote&id=' + id + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			loader.style.display = 'none';
			document.getElementById('rsc_comment').value = '[quote name="'+name+'"]'+responseText + '[/quote]';
			document.getElementById('rsc_IdComment').value = '';
			var scroll = new Fx.Scroll(window, { wait: false, duration: 700, transition: Fx.Transitions.Quad.easeInOut });
			scroll.toElement(document.getElementById('rsc_comment'));
			initTooltips();
		}
	});
	req.send();
}

// Edit comment
function rsc_edit(id) {
	if (!isset(document.getElementById('rscommentsFormContainer')))
		return;
	
	var loader = document.getElementById('rsc_loading_form');
	loader.style.display = '';
	
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.edit&id=' + id + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			loader.style.display = 'none';
			response = responseText;
			response = eval("(" + response + ")");
			if(response.error && response.error.length > 0) {
				alert(response.error);
				return;
			}
			
			document.getElementById('rsc_IdComment').value = response.IdComment;
			document.getElementById('rsc_id_parent').value = response.IdParent;
			document.getElementById('rsc_name').value = response.name;
			document.getElementById('rsc_email').value = response.email;
			if (isset(document.getElementById('rsc_subject')))
				document.getElementById('rsc_subject').value = response.subject;
			if (isset(document.getElementById('rsc_website')))
				document.getElementById('rsc_website').value = response.website;
			document.getElementById('rsc_comment').value = response.comment;
			document.getElementById('rsc_name').disabled = false;
			document.getElementById('rsc_email').disabled = false;
			var scroll = new Fx.Scroll(window, { wait: false, duration: 700, transition: Fx.Transitions.Quad.easeInOut });
			scroll.toElement(document.getElementById('rsc_comment'));
			
			initTooltips();
		}
	});
	req.send();
}

// Delete function 
function rsc_delete_fn(confirmText, id) {
	var shake = new Shake('rscomment'+id , {loops: 50});
	shake.shake();
	
	if(confirm(confirmText)) 
		rsc_delete(id);
	else shake.stop();
}

// Delete comment
function rsc_delete(id) {
	var container = document.getElementById('rscomment'+id);
	var loader = document.getElementById('rsc_loading_top');
	loader.style.display = '';
	
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.remove&id=' + id + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			loader.style.display = 'none';
			var response = responseText;

			response = eval("(" + response + ")");
			if(response != '') {
				if (response.error && response.error.length > 0) {
					alert(response.error);
					return;
				} else {
					if(container) {
						rsc_delete_animation(id,container);
					}
					
					var comments = response.deleted_children.split(',');
					for (i=0;i<comments.length;i++) {
						if (document.getElementById('rscomment'+comments[i])) {
							rsc_delete_animation(comments[i],document.getElementById('rscomment'+comments[i]));
						}
					}
				}
			}
			
			initTooltips();
		}
	});
	req.send();
}

// Delete comment animtaion
function rsc_delete_animation(id, container) {
	var rscEffect = new Fx.Morph('rscomment'+id, {
		duration: 'normal',
		transition: Fx.Transitions.Sine.easeOut,
		onComplete: function(){
			container.parentNode.removeChild(container);
		}
	});

	rscEffect.start({
		'opacity': 0
	});
}

// Publish comment
function rsc_publish(id) {
	var container = document.getElementById('rsc_publish'+id);
	var loader = document.getElementById('rsc_loading_top');
	loader.style.display = '';
	
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.publish&id=' + id + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			loader.style.display = 'none';
			container.innerHTML = responseText;
			$$('#rscomment'+id+' .rsc_buttons_container span').setStyle('display','');
			rsc_pubunpub_animation(id, '1');
			initTooltips();
		}
	});
	req.send();
}

// Unpublish comment
function rsc_unpublish(id) {
	var container = document.getElementById('rsc_publish'+id);
	var loader = document.getElementById('rsc_loading_top');
	loader.style.display = '';
	
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.unpublish&id=' + id + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			loader.style.display = 'none';
			container.innerHTML = responseText;
			$$('#rscomment'+id+' .rsc_buttons_container span').setStyle('display','none');
			rsc_pubunpub_animation(id, '0.6');
			initTooltips();
		}
	});
	req.send();
}

// Publish/Unpublish animation
function rsc_pubunpub_animation(id, opacity) {
	var rscEffect = new Fx.Morph('rscomment'+id, {
		duration: 'normal',
		transition: Fx.Transitions.Sine.easeOut
	});

	rscEffect.start({
		'opacity': opacity
	});
}

// Reset form
function rsc_reset_form() {
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=reset&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			document.getElementById('rscommentsForm').reset();
			
			for (i=0; i<document.getElementById('rscommentsForm').elements.length; i++)
				$(document.getElementById('rscommentsForm').elements[i]).removeClass('invalid');
			initTooltips();
		}
	});
	req.send();
}

// Pagination
function rsc_pagination(page, option, id, template, override) {
	var container_childs = document.getElementById('rscomments_big_container').getElementsByTagName('div');
	var count_comments = 0;
	var total = parseInt(document.getElementById('rsc_total').innerHTML);

	for(i=0;i<container_childs.length;i++)
		if(container_childs[i].id.substr(0,9) == 'rscomment') count_comments++;

	var limitstart = count_comments;
	var loader = document.getElementById('rsc_loading_pages');
	
	loader.style.display = '';
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=pagination&override=' + override + '&content=' + option + '&id=' + id + '&rsctemplate=' + template + '&limitstart=' + limitstart + '&pagination=0&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			loader.style.display = 'none';
			var htmlresponse 		= new Element('div');
			htmlresponse.id 		='rsc_tmp_'+limitstart;
			htmlresponse.innerHTML 	= responseText;

			$$('#rsc_comments_list').adopt(htmlresponse);
			rsc_initTooltips(htmlresponse.id,true);
			
			var scroll = new Fx.Scroll(window, { wait: false, duration: 700, transition: Fx.Transitions.Quad.easeInOut });
			scroll.toElement(document.getElementById('rsc_tmp_'+limitstart));
			
			rsc_shuffle();
			
			if ($$('#rsc_comments_list div[id^=rscomment]').length >= total) {
				var rsc_pagination = document.getElementById('rsc_global_pagination');
				rsc_pagination.parentNode.removeChild(rsc_pagination);
			}

			rsc_initModal();
		}
	});
	req.send();
}

function rsc_shuffle() {
	var hash = window.location.hash;
	if (hash.indexOf('#rscomment') != -1) {
		var cid = hash.replace('#','');
		if (!isset(document.getElementById(cid))) {
			document.getElementById('rscommentsPagination').click();
		} else {
			
			window.setTimeout(function() {
				newscroll = new Fx.Scroll(window, { wait: false, duration: 700, transition: Fx.Transitions.Quad.easeInOut });
				newscroll.toElement(document.getElementById(cid));
			},1000);
			
		}
	}
}

// Refresh captcha
function rsc_refresh_captcha(root,url_captcha) {
	sign = (url_captcha.indexOf('?') == -1) ? '?' : '&';
	document.getElementById('submit_captcha_image').src = root+url_captcha+sign+'sid=' + Math.random();
	document.getElementById('submit_captcha').value = '';
	return false;
}

// Validate form
function rsc_validate(upload,url_captcha) {
	var fields;
	var loader 		= document.getElementById('rsc_loading_form');
	var submit_btn 	= document.getElementById('rsc_submit');

	var params = new Array();
	for (i=0; i<document.getElementById('rscommentsForm').elements.length; i++) {
		
		if (document.getElementById('rscommentsForm').elements[i].type == 'button')
			continue;
		
		//remove the error
		$(document.getElementById('rscommentsForm').elements[i]).removeClass('invalid');

		var fname   = document.getElementById('rscommentsForm').elements[i].name;
		var fvalue  = document.getElementById('rscommentsForm').elements[i].value;
		var fnameid = document.getElementById('rscommentsForm').elements[i].id;
		
		// don't send an empty value
		if (fname.length == 0) continue;
		
		if (fname.indexOf('rsc_terms') != -1 ) {
			ie_version = rsc_get_ie();
			if (ie_version > -1 && ie_version >= 9) {
				var found = getElementsByClassName('rokrsc_terms');
				if (found.length > 0) {
					for (var f=0; f<found.length; f++) {
						if (found[f].className.indexOf('rokchecks-active') > -1)
							document.getElementById(fnameid).checked = true;
						else
							document.getElementById(fnameid).checked = false;
					}
				}
			}

			if (document.getElementById(fnameid).checked)
				fvalue = 1;
			else
				fvalue = 0;
		}

		if (fnameid == 'rsc_subscribe_thread' ) {
			if ( (document.getElementById('rsc_subscribe_thread') && document.getElementById('rsc_subscribe_thread').checked) )
				fvalue = 1;
			else
				fvalue = 0;
		}

		params.push(fname + '=' + encodeURIComponent(fvalue));
	}

	loader.style.display = '';
	submit_btn.disabled  = true;
	
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.validate&' + params.join('&') + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			loader.style.display = 'none';
			submit_btn.disabled = false;
			var response = responseText;
			response = eval("(" + response + ")");

			if(response.ErrorMessage && response.ErrorMessage.length > 0) {
				fields = response.ErrorKeys;
				fields = fields.split('\n');
				
				for(i=0;i<fields.length;i++) {
					if(typeof fields[i] == 'undefined') continue;
					if (fields[i] == 'comment')
						$$('#rscommentsForm textarea[name=jform['+fields[i]+']]').addClass('invalid');
					else
						$$('#rscommentsForm input[name=jform['+fields[i]+']]').addClass('invalid');
					
					if (fields[i] == 'name') {
						$$('#rscommentsForm input[name=jform['+fields[i]+']]').each(function (el) {
							if(el.disabled) {
								el.disabled = false;
							}
						});
					}
				}
				
				// reload captcha
				sign = (url_captcha.indexOf('?') == -1) ? '?' : '&';
				if (document.getElementById('submit_captcha_image')) {
					document.getElementById('submit_captcha_image').src = url_captcha+sign+'sid=' + Math.random();
					document.getElementById('submit_captcha').value = '';
				}

				// reload recaptcha
				if (document.getElementById('rsc_recaptcha')) {
					document.getElementById('recaptcha_response_field').value = '';
					Recaptcha.reload();
				}
				
				alert(response.ErrorMessage);
			}
			else {
				if(upload == 1) 
					rsc_upload(url_captcha);
				else 
					rsc_save(url_captcha);
			}
		}
	});
	req.send();
}

// Save comment
function rsc_save(url_captcha) {
	var fields;
	var loader 		= document.getElementById('rsc_loading_form');
	var submit_btn 	= document.getElementById('rsc_submit');

	var params = new Array();
	for (i=0; i<document.getElementById('rscommentsForm').elements.length; i++) {
		
		if (document.getElementById('rscommentsForm').elements[i].type == 'button')
			continue;
		
		//remove the error
		$(document.getElementById('rscommentsForm').elements[i]).removeClass('invalid');

		var fname   = document.getElementById('rscommentsForm').elements[i].name;
		var fvalue  = document.getElementById('rscommentsForm').elements[i].value;
		var fnameid = document.getElementById('rscommentsForm').elements[i].id;
		
		// don't send an empty value
		if (fname.length == 0) continue;
		
		if (fname.indexOf('rsc_terms') != -1 ) {
			ie_version = rsc_get_ie();
			if (ie_version > -1 && ie_version >= 9) {
				var found = getElementsByClassName('rokrsc_terms');
				if (found.length > 0) {
					for (var f=0; f<found.length; f++) {
						if (found[f].className.indexOf('rokchecks-active') > -1)
							document.getElementById(fnameid).checked = true;
						else
							document.getElementById(fnameid).checked = false;
					}
				}
			}

			if (document.getElementById(fnameid).checked)
				fvalue = 1;
			else
				fvalue = 0;
		}

		if (fnameid == 'rsc_subscribe_thread' ) {
			if ((document.getElementById('rsc_subscribe_thread') && document.getElementById('rsc_subscribe_thread').checked))
				fvalue = 1;
			else
				fvalue = 0;
		}

		params.push(fname + '=' + encodeURIComponent(fvalue));
	}
	
	loader.style.display = '';
	submit_btn.disabled  = true;
	
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.save&' + params.join('&') + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			loader.style.display = 'none';
			submit_btn.disabled = false;
			var response = responseText;

			if(response != '') {
				response = eval("(" + response + ")");
				if (response.ErrorMessage && response.ErrorMessage.length > 0) {
					fields = response.ErrorKeys;
					fields = fields.split('\n');					
					
					for(i=0;i<fields.length;i++) {
						if(typeof fields[i] == 'undefined') continue;
						if (fields[i] == 'comment')
							$$('#rscommentsForm textarea[name=jform['+fields[i]+']]').addClass('invalid')
						else
							$$('#rscommentsForm input[name=jform['+fields[i]+']]').addClass('invalid')
					}
					alert(response.ErrorMessage);
				} else {
					// reset the fields inside the comment form
					document.getElementById('rscommentsForm').reset();
					document.getElementById('rsc_id_parent').value 		= '0';
					document.getElementById('rsc_cancel').style.display = 'none';
					document.getElementById('rsc_IdComment').value 		= '';

					var responseComment			= document.createElement('div');
					responseComment.id 			= 'rscomment_tmp'+response.IdComment;
					responseComment.innerHTML 	= response.HtmlComment;

					var success_message 		= document.createElement('div');
					success_message.id 			= typeof response.IdComment == 'undefined' ? 'rscsuccess0' : 'rscsuccess'+response.IdComment;
					success_message.innerHTML 	= response.SuccessMessage;
					
					// this happens when a comment is edit
					if (isset(document.getElementById(responseComment.id))) {
						if(document.getElementById(responseComment.id))
							document.getElementById(responseComment.id).parentNode.removeChild(document.getElementById(responseComment.id));
					} else {
						if(document.getElementById('rscomment'+response.IdComment))
							document.getElementById('rscomment'+response.IdComment).parentNode.removeChild(document.getElementById('rscomment'+response.IdComment));
					}
					
					// add at the top of the array
					if(response.Referrer == 0)
						document.getElementById('rsc_comments_list').insertBefore(responseComment, document.getElementById('rsc_comments_list').firstChild);
					else 
						if(document.getElementById('rscomment'+response.Referrer))
							insertAfter(document.getElementById('rscomment'+response.Referrer),responseComment);
					
					//move form to it's original place
					$$('#rscommentsFormContainer').adopt($$('#rscommentsForm'));
					
					// add success message
					document.getElementById('rscommentsFormContainer').insertBefore(success_message, document.getElementById('rscommentsForm'));
					
					// add tooltip to the inserted form 
					rsc_initTooltips(responseComment.id,true);
					
					// scroll to comment
					if (response.IdComment) {
						var scroll = new Fx.Scroll(window, { wait: false, duration: 700, transition: Fx.Transitions.Quad.easeInOut });
						scroll.toElement($('rscomment'+response.IdComment));
					}
					
					// remove the success_message
					setTimeout(function() {
						hideMessage(response.IdComment);
					},3500);
					
					
					// reload captcha
					sign = (url_captcha.indexOf('?') == -1) ? '?' : '&';
					if(document.getElementById('submit_captcha_image')) {
						document.getElementById('submit_captcha_image').src = url_captcha+sign+'sid=' + Math.random();
						document.getElementById('submit_captcha').value = '';
					}

					// reload recaptcha
					if(document.getElementById('rsc_recaptcha')) {
						document.getElementById('recaptcha_response_field').value = '';
						Recaptcha.reload();
					}
				}
			
				var commentformfields = $$('rscommentsForm p label');
				for(i=0;i<commentformfields;i++)
					$(commentformfields[i]).removeClass('hasTip');

				rsc_initModal();
			}
		}
	});
	req.send();
}

// Hide success message
function hideMessage(id) {
	id = typeof id == 'undefined' ? 0 : id;
	
	if (isset($('rscsuccess'+id))) {
		$('rscsuccess'+id).set('tween', {
			onComplete: function() {
				$('rscsuccess'+id).dispose();
			}
		}).tween('opacity', 0);
	}
}

// Open thread
function rsc_open(id,option,override) {
	document.getElementById('rsc_loading_top').style.display = '';
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.openthread&id=' + id + '&opt=' + option + '&override=' + override + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			document.getElementById('rsc_loading_top').style.display = 'none';
			var response = responseText;
			
			if(response != '') {
				response = eval("(" + response + ")");
				if (response.status) {
					$('rscommentsFormMainContainer').innerHTML = response.form;
					document.getElementById('rsc_thread').innerHTML = response.link;
					
					$$('div.rsc_buttons_container').each(function (el) {
						if (isset(el))
							el.style.display = '';
					})
					
					alert(response.message);
				} else {
					document.getElementById('rsc_thread').innerHTML = response.link;
					alert(response.message);
				}
			}
			initTooltips();
		}
	});
	req.send();
}

// Close thread
function rsc_close(id,option,override) {
	document.getElementById('rsc_loading_top').style.display = '';
	root = typeof rsc_root != 'undefined' ? rsc_root : '';
	var req = new Request({
		method: 'post',
		url: root+'index.php?option=com_rscomments',
		data: 'task=comments.closethread&id=' + id + '&opt=' + option + '&override=' + override + '&randomTime='+Math.random(),
		onSuccess: function(responseText, responseXML) {
			document.getElementById('rsc_loading_top').style.display = 'none';
			var response = responseText;
			
			if(response != '') {
				response = eval("(" + response + ")");
				if (response.status) {
					$('rscommentsFormMainContainer').innerHTML = '';
					document.getElementById('rsc_thread').innerHTML = response.link;
					
					$$('div.rsc_buttons_container').each(function (el) {
						if (isset(el))
							el.style.display = 'none';
					});
					
					alert(response.message);
				} else {
					document.getElementById('rsc_thread').innerHTML = response.link;
					alert(response.message);
				}
			}
			initTooltips();
		}
	});
	req.send();
}

function rsc_view(id) {
	if (document.getElementById('c'+id).style.display == 'none') {
		document.getElementById('c'+id).style.display = '';
	} else {
		document.getElementById('c'+id).style.display = 'none';
	}
}