<?php
/**
* @package RSComments!
* @copyright (C) 2014 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined('_JEXEC') or die('Restricted access');

class RSCommentsControllerComments extends JControllerLegacy
{
	public function __construct() {
		parent::__construct();

		// Comments Tasks
		$this->registerTask('publish', 	  		'changestatus');
		$this->registerTask('unpublish',   		'changestatus');
		
		$this->registerTask('voteup', 	   		'changevote');
		$this->registerTask('votedown',    		'changevote');
		
		$this->registerTask('openthread',  		'changethreadstatus');
		$this->registerTask('closethread', 		'changethreadstatus');
		
		$this->registerTask('subscribe',   		'subscribe');
		$this->registerTask('unsubscribe', 		'subscribe');
		$this->registerTask('unsubscribeemail', 'subscribe');
	}
	
	// Subscribe user
	public function subscribeuser() {
		// Get the model
		$model 	= $this->getModel('comments');
		$result = $model->subscribeuser();
		
		echo '<div style="padding: 70px;text-align: center;">'.$result['message'].'</div>';
		echo '<script type="text/javascript">';
		echo "setTimeout('window.parent.SqueezeBox.close();',1500)";
		echo '</script>';
		JFactory::getApplication()->close();
	}
	
	//Comments - Subscribe / Unsubscribe user
	public function subscribe() {
		$app	= JFactory::getApplication();
		$jinput	= $app->input;
		$task	= $jinput->get('task','');
		$model	= $this->getModel('comments');
		$id		= $jinput->get('id');
		$option = $jinput->get('opt');
		$row	= $task == 'subscribe' ? $model->subscribe() : $model->unsubscribe();
		
		if($task == 'subscribe') {
			$msg = $row ? JText::_('COM_RSCOMMENTS_SUBSCRIBED') : JText::_('COM_RSCOMMENTS_ALREADY_SUBSCRIBED');
			$function = 'rsc_unsubscribe(\''.$id.'\',\''.$option.'\')';
			$text = JText::_('COM_RSCOMMENTS_UNSUBSCRIBE');
		} else {
			$msg = $row ? JText::_('COM_RSCOMMENTS_UNSUBSCRIBED') : JText::_('COM_RSCOMMENTS_ALREADY_UNSUBSCRIBED');
			
			if($task == 'unsubscribeemail') {
				$redirect_url = $jinput->getString('redirect_url');
				if($row == false && !empty($redirect_url)) $msg = JText::_('COM_RSCOMMENTS_INVALID_LINK');
				$app->redirect(JURI::root().base64_decode(JRoute::_($redirect_url)),$msg);
			}
			
			$function = 'rsc_subscribe(\''.$id.'\',\''.$option.'\')';
			$text = JText::_('COM_RSCOMMENTS_SUBSCRIBE');
		}
		
		echo $msg.'|<a class="'.RSTooltip::tooltipClass().'" href="javascript:void(0);" onclick="'.$function.'" title="'.RSTooltip::tooltipText($text).'"><img src="'.JURI::root().'components/com_rscomments/assets/images/subscribe.png" alt="'.$text.'" /> '.$text.'</a>';
		$app->close();
	}
	
	// Comments - Vote
	public function changevote() {		
		$app	= JFactory::getApplication();
		$jinput	= $app->input;
		$task	= $jinput->get('task','');
		$model	= $this->getModel('comments');
		$id		= $jinput->getInt('id');
		$value	= $task == 'voteup' ? 1 : 0;
		
		echo $model->vote($id, $value);
		$app->close();
	}
	
	//Comments - Quote
	public function quote() {
		$model	= $this->getModel('comments');
		$row	= $model->getComment();
		echo !empty($row) ? $row->comment : '';
		JFactory::getApplication()->close();
	}
	
	//Comments - Edit
	public function edit() {
		$model 			= $this->getModel('comments');
		$session 		= JFactory::getSession();
		$id 			= JFactory::getApplication()->input->get('id');
		$owner 			= RSCommentsHelper::isAuthor($id); 
		$permissions 	= RSCommentsHelper::getPermissions();
		$row 			= $model->getComment();
		$ThreadClosed	= RSCommentsHelper::getThreadStatus($row->id,$row->option);

		if (!(((isset($permissions['edit_own_comment']) && $permissions['edit_own_comment']) && $owner && !$ThreadClosed) || (isset($permissions['edit_comments']) && $permissions['edit_comments'] && !$ThreadClosed))) {
			echo json_encode(array('error' => JText::_('RSC_ERROR_EDIT_PERMISSIONS')));
			JFactory::getApplication()->close();
		}

		$session->set('com_rscomments.IdComment', $row->IdComment);

		$return = array();
		$return['IdComment'] = $row->IdComment;
		$return['IdParent']	 = $row->IdParent;
		$return['name'] 	 = html_entity_decode($row->name,ENT_COMPAT,'UTF-8');
		$return['email'] 	 = $row->email;
		$return['subject'] 	 = html_entity_decode($row->subject,ENT_COMPAT,'UTF-8');
		$return['website'] 	 = $row->website;
		$return['comment'] 	 = $row->comment;
		
		echo json_encode($return);
		JFactory::getApplication()->close();
	}
	
	// Comments - Remove
	public function remove() {
		$model	= $this->getModel('comments');
		$return	= $model->remove(JFactory::getApplication()->input->getInt('id'));
		
		echo json_encode($return);
		JFactory::getApplication()->close();
	}
	
	// Comments - Publish/Unpublish
	public function changestatus() {
		$model	= $this->getModel('comments');
		$app	= JFactory::getApplication();
		$jinput	= $app->input;
		$task	= $jinput->get('task','');
		$id		= $jinput->getInt('id',0);
		$value	= $task == 'publish' ? 1 : 0;
		
		$model->publish($id, $value);
		
		$publish 	= ($value == 1) ? 'unpublish' : 'publish'; 
		$function 	= ($value == 1) ? 'rsc_unpublish(\''.$id.'\')' : 'rsc_publish(\''.$id.'\')'; 
		$message 	= ($value == 1) ? JText::_('COM_RSCOMMENTS_UNPUBLISH') : JText::_('COM_RSCOMMENTS_PUBLISH');
		
		echo '<a class="'.RSTooltip::tooltipClass().'" href="javascript:void(0);" onclick="'.$function.'" title="'.RSTooltip::tooltipText($message).'"><img src="'.JURI::root().'components/com_rscomments/assets/images/'.$publish.'.png" alt="'.$message.'" /></a>';
		$app->close();
	}
	
	// validate the form 	
	public function validate() {
		$model 	= $this->getModel('comments');
		$return = $model->validate();

		if(is_array($return)) {
			$response = array();
			$response['ErrorMessage'] 	= implode("\n",$return);
			$response['ErrorKeys'] 		= implode("\n",array_keys($return));
			$return = $response;
		}
		
		echo json_encode($return);
		JFactory::getApplication()->close();
	}
	
	// Comments - Save
	public function save() {
		$app		= JFactory::getApplication();
		$jinput		= $app->input;
		$model		= $this->getModel('comments');
		$config		= RSCommentsHelper::getConfig();
		$comment	= $model->save();
		
		if($comment == false) 
			return;

		if(is_array($comment)) {
			$response = array();
			$response['ErrorMessage'] 	= implode("\n",$comment);
			$response['ErrorKeys'] 		= implode("\n",array_keys($comment));

			echo json_encode($response);
			$app->close();
		}

		$template = RSCommentsHelper::getTemplate();
		$override = $jinput->getInt('override');
		
		$class 		= new RSCommentsModelComments($comment->id, $comment->option, $config->nr_comments, $template, $override);
		$pagination = $class->getPagination();
		$last_page 	= $pagination->get('pages.stop');
		$limitstart = $last_page > 0 ? ($last_page -1) * $pagination->limit : 0;
		
		$jinput->set('limitstart',$limitstart);
		$jinput->set('pagination',0);

		$permissions 	= RSCommentsHelper::getPermissions();
		$ThreadClosed	= RSCommentsHelper::getThreadStatus($comment->id,$comment->option);
		
		$data				= $class->buildDataArray();
		$comments_flat_list = $data;
		$comments_keys 		= array_keys($comments_flat_list);
		$comment_position	= 0;
		
		foreach ($comments_keys as $key => $val) {
			if($val == $comment->IdComment) {
				$comment_position = $key; 
				break;
			}
		}

		$comm = array();
		if(!empty($data) && array_key_exists($comment->IdComment, $data)) {
			$comm['IdComment'] 			= $comment->IdComment;
			$comm['Level']  			= !empty($data) ? $data[$comment->IdComment] : 0;
			$comm['HtmlComment'] 		= RSCommentsHelper::showComments($comment->option, $comment->id,$template,null,$override,'items',$comment->IdComment);
			$comm['NrComments'] 		= $config->nr_comments;
			$comm['Option']				= $comment->option;
			$comm['OptionId']			= $comment->id;
			$comm['Template']			= $template;
			$comm['CommentsOrdering']	= $config->default_order;
			$comm['Referrer']			= ($comment_position != 0) ? $comments_keys[($comment_position-1)] : 0;
		}
		
		if (isset($permissions['autopublish']) && empty($permissions['autopublish'])) {
			$msg = JText::_('COM_RSCOMMENTS_COMMENT_SAVED_UNPUBL');
			$comm['SuccessMessage'] = '<div id="rsc_message" class="rsc_message">'.$msg.' <a href="javascript:void(0)" onclick="hideMessage(0);">'.JText::_('COM_RSCOMMENTS_CLOSE').'</a></div>';
		} else {
			$msg = JText::_('COM_RSCOMMENTS_COMMENT_SAVED');
			$comm['SuccessMessage'] = '<div id="rsc_message" class="rsc_message">'.$msg.' <a href="javascript:void(0)" onclick="hideMessage('.$comment->IdComment.');">'.JText::_('COM_RSCOMMENTS_CLOSE').'</a></div>';
		}
		
		echo json_encode($comm);
		$app->close();
	}
	
	// Comments - Open/Close thread
	public function changethreadstatus() {
		$model	= $this->getModel('comments');
		$app	= JFactory::getApplication();
		$jinput	= $app->input;
		$task	= $jinput->get('task','');
		$id		= $jinput->getString('id',0);
		$option	= $jinput->getString('opt','');
		$return	= $task == 'openthread' ? $model->openthread() : $model->closethread();
		$override = $jinput->getInt('override','');
		$response = array();
		
		if($task == 'openthread') {
			$msg		= $return['message'];
			$function	= $return['status'] ? 'rsc_close(\''.$id.'\',\''.$option.'\',\''.$override.'\');' : 'rsc_open(\''.$id.'\',\''.$option.'\',\''.$override.'\')';
			$text		= JText::_('COM_RSCOMMENTS_CLOSE_THREAD');
			$image		= $return['status'] ? RSCommentsHelper::ImagePath('thread-close-14x14.png') : RSCommentsHelper::ImagePath('thread-open-14x14.png');
		} else {
			$msg		= $return['message'];
			$function	= $return['status'] ? 'rsc_open(\''.$id.'\',\''.$option.'\',\''.$override.'\');' : 'rsc_close(\''.$id.'\',\''.$option.'\',\''.$override.'\')';
			$text		= JText::_('COM_RSCOMMENTS_OPEN_THREAD');
			$image		= $return['status'] ? RSCommentsHelper::ImagePath('thread-open-14x14.png') : RSCommentsHelper::ImagePath('thread-close-14x14.png');
		}
		
		$response['status']		= $return['status'];
		$response['message']	= $msg;
		$response['link']		= '<a class="'.RSTooltip::tooltipClass().'" href="javascript:void(0);" onclick="'.$function.'" title="'.RSTooltip::tooltipText($text).'"><img src="'.$image.'" alt="'.$text.'" /> '.$text.'</a>';
		$response['form']		= RSCommentsHelper::displayForm($option, $id, $override);
		
		echo json_encode($response);
		$app->close();
	}
	
	// Get user comments for CB
	public function cbcomments() {
		$jinput	= JFactory::getApplication()->input;
		$userid	= $jinput->getString('userid');
		$start	= $jinput->getString('start');
		$limit	= $jinput->getString('limit');
		
		$comments = RSCommentsHelper::getCBUserComments($userid,$start,$limit);
		echo json_encode($comments);
		JFactory::getApplication()->close();
	}
	
	// Report comment
	public function report() {
		$config		= RSCommentsHelper::getConfig();
		
		if (!$config->enable_reports) {
			echo '<script type="text/javascript">';
			echo "setTimeout('window.parent.SqueezeBox.close();',1500)";
			echo '</script>';
			JFactory::getApplication()->close();
		}
		
		$model	= $this->getModel('comments');		
		$data = $model->report();
		
		if ($data['success']) {
			echo '<div style="padding: 70px;text-align: center;">'.JText::_('COM_RSCOMMENTS_REPORT_SAVED').'</div>';
			echo '<script type="text/javascript">';
			echo "setTimeout('window.parent.SqueezeBox.close();',1500)";
			echo '</script>';
			JFactory::getApplication()->close();
		} else {
			$this->setMessage($data['message']);
			$this->setRedirect(JRoute::_('index.php?option=com_rscomments&layout=report&tmpl=component&id='.$data['id'], false));
		}
	}
}