<?php
/**
* @package RSComments!
* @copyright (C) 2014 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined('_JEXEC') or die('Restricted access'); ?>

<div class="rscomments_big_container" id="rscomments_big_container">
	<hr class="rsc_line" />
	<div class="rsc_options">
		<?php
			if ($this->config->enable_subscription) {
				if (RSCommentsHelper::isSubscribed($this->id, $this->option)) {
					if ($this->user->get('id') > 0) { ?>
						<span id="rsc_subscr">
							<a class="<?php echo RSTooltip::tooltipClass(); ?>" href="javascript:void(0);" onclick="rsc_unsubscribe('<?php echo $this->id; ?>','<?php echo $this->option; ?>')" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_UNSUBSCRIBE')); ?>">
								<img src="<?php echo RSCommentsHelper::ImagePath('subscribe.png'); ?>" alt="<?php echo JText::_('COM_RSCOMMENTS_UNSUBSCRIBE'); ?>" /> <?php echo JText::_('COM_RSCOMMENTS_UNSUBSCRIBE'); ?>
							</a>
						</span>
		<?php 		}
				} else {
					if ($this->user->get('id') > 0) { ?>
						<span id="rsc_subscr">
							<a class="<?php echo RSTooltip::tooltipClass(); ?>" href="javascript:void(0);" onclick="rsc_subscribe('<?php echo $this->id; ?>','<?php echo $this->option; ?>')" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_SUBSCRIBE')); ?>">
								<img src="<?php echo RSCommentsHelper::ImagePath('subscribe.png'); ?>"  alt="<?php echo JText::_('COM_RSCOMMENTS_SUBSCRIBE'); ?>" /> <?php echo JText::_('COM_RSCOMMENTS_SUBSCRIBE'); ?>
							</a>
						</span>
		<?php		} else { ?>
						<span id="rsc_subscr">
							<a href="<?php echo RSCommentsHelper::route('index.php?option=com_rscomments&layout=subscribe&theoption='.$this->option.'&id='.$this->id.'&tmpl=component'); ?>" rel="{handler: 'iframe', size: {x: 400, y: 220}}" class="rs_modal <?php echo RSTooltip::tooltipClass(); ?>" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_SUBSCRIBE')); ?>">
								<img src="<?php echo RSCommentsHelper::ImagePath('subscribe.png'); ?>" alt="<?php echo JText::_('COM_RSCOMMENTS_SUBSCRIBE'); ?>" /> <?php echo JText::_('COM_RSCOMMENTS_SUBSCRIBE'); ?>
							</a>
						</span>
		<?php		}
				}
			}
			
			if ($this->config->enable_rss) { ?>
				<a class="<?php echo RSTooltip::tooltipClass(); ?>" href="<?php echo RSCommentsHelper::route('index.php?option=com_rscomments&format=feed&type=rss&opt='.$this->option.'&id='.$this->id); ?>" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_RSS')); ?>">
					<img src="<?php echo RSCommentsHelper::ImagePath('rss.png'); ?>" alt="<?php echo JText::_('COM_RSCOMMENTS_RSS'); ?>" /> <?php echo JText::_('COM_RSCOMMENTS_RSS'); ?>
				</a>
		<?php }
		
			if (isset($this->permissions['close_thread']) && $this->permissions['close_thread'] == 1) {
				if (RSCommentsHelper::getThreadStatus($this->id,$this->option)) { ?>
					<span id="rsc_thread">
						<a class="<?php echo RSTooltip::tooltipClass(); ?>" href="javascript:void(0);" onclick="rsc_open('<?php echo $this->id; ?>','<?php echo $this->option; ?>','<?php echo (int) $this->override; ?>');" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_OPEN_THREAD')); ?>">
							<img src="<?php echo RSCommentsHelper::ImagePath('thread-open-14x14.png'); ?>" alt="<?php echo JText::_('COM_RSCOMMENTS_OPEN_THREAD'); ?>" /> <?php echo JText::_('COM_RSCOMMENTS_OPEN_THREAD'); ?>
						</a> 
					</span>
		<?php	} else { ?>
					<span id="rsc_thread">
						<a class="<?php echo RSTooltip::tooltipClass(); ?>" href="javascript:void(0);" onclick="rsc_close('<?php echo $this->id; ?>','<?php echo $this->option; ?>','<?php echo (int) $this->override; ?>');" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_CLOSE_THREAD')); ?>">
							<img src="<?php echo RSCommentsHelper::ImagePath('thread-close-14x14.png'); ?>" alt="<?php echo JText::_('COM_RSCOMMENTS_CLOSE_THREAD'); ?>" /> <?php echo JText::_('COM_RSCOMMENTS_CLOSE_THREAD'); ?>
						</a> 
					</span>
		<?php 	}
			} ?>
	</div>
	
	<div class="rs_clear"></div>
	
	<div id="rsc_loading_top" style="display:none;">
		<img src="<?php echo RSCommentsHelper::ImagePath('loader.gif'); ?>" alt="" />
	</div>
	
	<div id="rsc_comments_list">
		<?php echo $this->loadTemplate('items'); ?>
	</div>
	
	<?php if ($this->pagination->get('pages.total') > 1) { ?>
	<div id="rsc_global_pagination" class="rsc_pagination">
		<?php if ($this->pagination->get('pages.current') != $this->pagination->get('pages.total')) { ?>
			<a id="rscommentsPagination" class="rsc_button btn btn-info" href="javascript:void(0);" onclick="rsc_pagination('<?php echo ($this->pagination->get('pages.current')*$this->config->nr_comments); ?>', '<?php echo $this->option; ?>', '<?php echo $this->id; ?>', '<?php echo $this->template; ?>', '<?php echo $this->override; ?>');">
				<?php echo JText::_('COM_RSCOMMENTS_LOAD_MORE_COMMENTS'); ?>
			</a>
		<?php } ?>
	</div>
	<span class="rsc_clear">&nbsp;</span>
	<?php } ?>
</div>

<div id="rsc_loading_pages" style="text-align:center;display:none;">
	<img src="<?php echo RSCommentsHelper::ImagePath('loader.gif'); ?>" alt="" />
</div>
<script type="text/javascript">rsc_initTooltips('rsc_comment_options');</script>
<div class="rsc_clear"></div>
<span style="display:none;" id="rsc_total"><?php echo $this->total; ?></span>