<?php
/**
* @package RSComments!
* @copyright (C) 2014 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined('_JEXEC') or die('Restricted access');

$thread 	= RSCommentsHelper::getThreadStatus($this->id,$this->option);
$ownComment = false;
$ip 		= $_SERVER['REMOTE_ADDR'];
if ($this->user->guest) {
	$ownComment = $this->comment->ip == $ip;
} else {
	$ownComment = $this->comment->uid == $this->user->id;
}
?>
<div id="rscomment<?php echo $this->comment->IdComment; ?>" class="rsc_comment_big_box<?php echo $this->comment->level; ?>" <?php echo !$this->comment->published ? 'style="opacity:0.6;"' : ''; ?>> 
	<?php if (RSCommentsHelper::isJ3()) { ?>
	<?php $name = RSCommentsHelper::name($this->comment, $this->permissions); ?>
	<div class="rsc_comment_container">
		<div class="rsc_cloud_comment">
			<div class="rsc_comment_content">
				<div class="rsc_avatar_container">
					
					<!-- Author name -->
					<span class="rsc_author">
						<strong><span id="rscname<?php echo $this->comment->IdComment; ?>"><?php echo $name['name']; ?></span></strong>
					</span>
					<!-- Author name -->
					
					<!-- User avatar with linked profile account -->
					<?php $socialLink = RSCommentsHelper::getUserSocialLink($this->comment->uid); ?>
					<?php if ($socialLink) { ?><a href="<?php echo $socialLink; ?>"><?php } ?>
					<?php echo RSCommentsHelper::getAvatar($this->comment->uid,$this->comment->email); ?>
					<?php if ($socialLink) { ?></a><?php } ?>
					<!-- User avatar with linked profile account -->
					
					<span class="rsc_clear">&nbsp;</span>
					
					<!-- User website -->
					<?php if ($this->config->enable_website_field == 1 && !empty($this->comment->website)) { ?>
					<a class="rsc_website" href="<?php echo $this->comment->website; ?>" <?php $this->config->nofollow_rel == 1 ? 'rel="nofollow"' : ''; ?> target="_blank" title="<?php echo JText::_('COM_RSCOMMENTS_WEBSITE'); ?>">
						<?php echo JText::_('COM_RSCOMMENTS_WEBSITE'); ?>
					</a>
					<?php } ?>
					<!-- User website -->
					
					<!-- Comment date -->
					<span class="rsc_date"><i><?php echo RSCommentsHelper::showDate($this->comment->date); ?></i></span>
					<!-- Comment date -->
				</div>
				
				<!-- Comment subject -->
				<span class="rsc_subject">
					<?php if ($this->config->enable_title_field == 1) { ?>
					<span id="rscsubject<?php echo $this->comment->IdComment; ?>"><?php echo $this->comment->subject; ?></span>
					<?php } ?>
				</span>
				<!-- Comment subject -->
				
				<!-- Comment voting -->
				<span class="rsc_voting">
				<?php if ($this->config->enable_votes) { ?>
				<?php $positive = '<a class="'.RSTooltip::tooltipClass().'" href="javascript:void(0);" onclick="rsc_pos(\''.$this->comment->IdComment.'\');" title="'.RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_GOOD_COMMENT')).'"><img src="'.RSCommentsHelper::ImagePath('voteyes.png').'" alt="'.JText::_('JYES').'" /></a> '; ?>
				<?php $negative = '<a class="'.RSTooltip::tooltipClass().'" href="javascript:void(0);" onclick="rsc_neg(\''.$this->comment->IdComment.'\');" title="'.RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_BAD_COMMENT')).'"><img src="'.RSCommentsHelper::ImagePath('voteno.png').'" alt="'.JText::_('JNO').'" /></a>'; ?>
				
				<?php if (isset($this->permissions['vote_comments']) && $this->permissions['vote_comments']) { ?>
				<?php $voted = RSCommentsHelper::voted($this->comment->IdComment); ?>
				<?php if (empty($voted)) { ?>
				<span id="rsc_voting<?php echo $this->comment->IdComment; ?>"><?php echo $positive.$negative; ?></span>
				<?php } else { ?>
				<?php if ($this->comment->pos - $this->comment->neg > 0) { ?>
				<img class="rsc_transparent" src="<?php echo RSCommentsHelper::ImagePath('voteyes.png') ?>" alt="<?php echo JText::_('JYES'); ?>" />
				<span class="rsc_green"><?php echo $this->comment->pos - $this->comment->neg; ?></span>
				<?php } else { ?>
				<img class="rsc_transparent" src="<?php echo RSCommentsHelper::ImagePath('voteno.png') ?>" alt="<?php echo JText::_('JNO'); ?>" />
				<span class="rsc_red"><?php echo $this->comment->pos - $this->comment->neg; ?></span>
				<?php } ?>
				<?php } ?>
				
				<?php } else { ?>
				<?php if ($this->comment->pos - $this->comment->neg > 0) { ?>
				<img class="rsc_transparent" src="<?php echo RSCommentsHelper::ImagePath('voteyes.png') ?>" alt="<?php echo JText::_('JYES'); ?>" />
				<span class="rsc_green"><?php echo $this->comment->pos - $this->comment->neg; ?></span>
				<?php } else { ?>
				<img class="rsc_transparent" src="<?php echo RSCommentsHelper::ImagePath('voteno.png') ?>" alt="<?php echo JText::_('JNO'); ?>" />
				<span class="rsc_red"><?php echo $this->comment->pos - $this->comment->neg; ?></span>
				<?php } ?>
				<?php } ?>
				
				<?php }	?>
				</span>
				<!-- Comment voting -->
				
				<!-- The Comment -->
				
				<?php $negativeComment = isset($this->config->negative_count) && $this->config->negative_count && $this->comment->neg >= $this->config->negative_count; ?>
				
				<?php if ($negativeComment) { ?>
				<span id="chidden<?php echo $this->comment->IdComment; ?>" class="rsc_comment_box"><?php echo JText::_('COM_RSCOMMENTS_COMMENT_HIDDEN'); ?> <a href="javascript:void(0);" onclick="rsc_view('<?php echo $this->comment->IdComment; ?>')"><?php echo JText::_('COM_RSCOMMENTS_COMMENT_HIDDEN_LINK'); ?></a></span>
				<?php } ?>
				
				<span id="c<?php echo $this->comment->IdComment; ?>" class="rsc_comment_box" <?php if ($negativeComment) { ?>style="display: none; opacity: 0.7;"<?php } ?>>
					<?php echo RSCommentsHelper::parseComment($this->comment->comment,$this->permissions); ?>
				</span>
				<!-- The Comment -->
				
				<!-- Comment buttons -->
				<div class="rsc_buttons_container">
					<?php if ($this->comment->published) { ?>
						<?php if (!empty($this->permissions['enable_reply']) && !$thread) { ?>
						<span class="btn" onclick="rsc_reply('<?php echo $this->comment->IdComment; ?>')">
							<a href="javascript:void(0);" title="<?php echo JText::_('COM_RSCOMMENTS_REPLY'); ?>"><?php echo JText::_('COM_RSCOMMENTS_REPLY'); ?></a>
						</span>
						<?php } ?>
						<?php if (isset($this->permissions['new_comments']) && $this->permissions['new_comments'] && !$thread) { ?>
						<span class="btn" onclick="rsc_quote('<?php echo $name['cleanname']; ?>', '<?php echo $this->comment->IdComment; ?>');">
							<a href="javascript:void(0);"><?php echo JText::_('COM_RSCOMMENTS_COMMENT_QUOTE'); ?></a>
						</span>
						<?php } ?>
					<?php } ?>
				</div>
				<!-- Comment buttons -->
				
				<div class="rsc_clear"></div>
				
				<!-- Last edited -->
				<?php if (isset($this->config->enable_modified) && $this->config->enable_modified) { ?>
				<?php if (!empty($this->comment->modified) && $this->comment->modified != JFactory::getDbo()->getNullDate()) { ?>
				<div class="rsc_modified">
					<?php echo JText::sprintf('COM_RSCOMMENTS_LAST_MODIFIED_ON',RSCommentsHelper::showDate($this->comment->modified)); ?>
					<?php $modified_by = $this->comment->modified_by ? JFactory::getUser($this->comment->modified_by)->get('name') : JText::_('COM_RSCOMMENTS_GUEST'); ?>
					<?php echo JText::sprintf('COM_RSCOMMENTS_LAST_MODIFIED_BY',$modified_by); ?>
				</div>
				<?php } ?>
				<?php } ?>
				<!-- Last edited -->
				
				<div id="rsc_replyform_container<?php echo $this->comment->IdComment; ?>" class="rsc_comment_box_form"></div>
			</div>
			
			<!-- Comment attachment -->
			<span class="rsc_attachment">
				<?php if (!empty($this->comment->file)) { ?>
				<a href="<?php echo RSCommentsHelper::route('index.php?option=com_rscomments&task=download&id='.$this->comment->IdComment,false);?>" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_ATTACHMENT')); ?>" class="<?php echo RSTooltip::tooltipClass(); ?>">
					<img src="<?php echo RSCommentsHelper::ImagePath('attachment.png'); ?>" alt="<?php echo JText::_('COM_RSCOMMENTS_ATTACHMENT'); ?>" /> <?php echo $this->comment->file; ?>
				</a>
				<?php } ?>
			</span>
			<!-- Comment attachment -->
			
			<!-- Comment options -->
			<div class="rsc_comment_options">
				
				<?php if ($this->config->enable_reports) { ?>
				<?php $iframeH = $this->config->enable_captcha_reports ? 420 : 255; ?>
				<a class="rs_modal <?php echo RSTooltip::tooltipClass(); ?>" rel="{handler: 'iframe', size: {x:450, y:<?php echo $iframeH; ?>}}" href="<?php echo JRoute::_('index.php?option=com_rscomments&layout=report&tmpl=component&id='.$this->comment->IdComment,false); ?>" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_REPORT_COMMENT')); ?>">
					<img src="<?php echo RSCommentsHelper::ImagePath('report.png'); ?>" alt="<?php echo JText::_('COM_RSCOMMENTS_REPORT_COMMENT'); ?>" />
				</a>
				<?php } ?>
				
				<?php if (isset($this->permissions['view_ip']) && $this->permissions['view_ip']) { ?>
				<a href="http://www.db.ripe.net/whois?searchtext=<?php echo $this->comment->ip; ?>" target="_blank" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_IP_ADDRESS'),$this->comment->ip); ?>" class="<?php echo RSTooltip::tooltipClass(); ?>">
					<img src="<?php echo RSCommentsHelper::ImagePath('info.png') ;?>" alt="" />
				</a>
				<?php } ?>
				
				<?php if (((isset($this->permissions['edit_own_comment']) && $this->permissions['edit_own_comment']) && $ownComment && !$thread) || (isset($this->permissions['edit_comments']) && $this->permissions['edit_comments'] && !$thread)) { ?>
				<a class="<?php echo RSTooltip::tooltipClass(); ?>" href="javascript:void(0);" onclick="rsc_edit('<?php echo $this->comment->IdComment; ?>');" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_EDIT_COMMENT')); ?>">
					<img src="<?php echo RSCommentsHelper::ImagePath('edit.png'); ?>" alt="<?php echo JText::_('COM_RSCOMMENTS_EDIT_COMMENT'); ?>" />
				</a>
				<?php } ?>
				
				<?php if (((isset($this->permissions['delete_own_comment']) && $this->permissions['delete_own_comment']) && $ownComment ) || (isset($this->permissions['delete_comments']) && $this->permissions['delete_comments'])) { ?>
				<a class="<?php echo RSTooltip::tooltipClass(); ?>" href="javascript:void(0);" onclick="rsc_delete_fn('<?php echo JText::_('COM_RSCOMMENTS_DELETE_COMMENT_CONFIRM',true); ?>', '<?php echo $this->comment->IdComment; ?>'); return false;" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_DELETE_COMMENT')); ?>">
					<img src="<?php echo RSCommentsHelper::ImagePath('trash.png'); ?>" alt="<?php echo JText::_('COM_RSCOMMENTS_DELETE_COMMENT'); ?>" />
				</a>
				<?php } ?>
				
				<?php if (isset($this->permissions['publish_comments']) && $this->permissions['publish_comments']) { ?>
				<?php $publish = ($this->comment->published == 1) ? 'unpublish' : 'publish'; ?>
				<?php $publish_image = RSCommentsHelper::ImagePath($publish.'.png'); ?>
				<?php $function = ($this->comment->published == 1) ? 'rsc_unpublish(\''.$this->comment->IdComment.'\')' : 'rsc_publish(\''.$this->comment->IdComment.'\')'; ?>
				<?php $message = ($this->comment->published == 1) ? JText::_('COM_RSCOMMENTS_UNPUBLISH') : JText::_('COM_RSCOMMENTS_PUBLISH'); ?>
				<span id="rsc_publish<?php echo $this->comment->IdComment; ?>">
					<a class="<?php echo RSTooltip::tooltipClass(); ?>" href="javascript:void(0);" onclick="<?php echo $function; ?>" title="<?php echo RSTooltip::tooltipText($message); ?>">
						<img src="<?php echo $publish_image; ?>" alt="<?php echo $message; ?>" />
					</a>
				</span>
				<?php } ?>
			</div>
			<!-- Comment options -->
		</div>
		<span class="rsc_clear">&nbsp;</span>
	</div>
	<?php } else { ?>
	<?php echo RSCommentsHelper::showComment($this->comment, $this->template, $thread); ?>
	<?php } ?>
</div>
<script type="text/javascript">rsc_initTooltips('rscomment<?php echo $this->comment->IdComment; ?>');</script>