<?php
/**
* @package RSComments!
* @copyright (C) 2014 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined('_JEXEC') or die('Restricted access');
JHtml::_('behavior.formvalidation'); ?>

<script type="text/javascript">rsc_reset_form();</script>
<div id="rscommentsFormContainer">
	<form id="rscommentsForm" name="rscommentsForm" action="javascript:void(0)" method="post">
		<?php if ($this->config->form_accordion) { ?>
		<div id="rsc_accordion_container">
			<span class="rsc_toggler">
				<?php echo JText::_('COM_RSCOMMENTS_HIDE_FORM'); ?> 
				<img id="rsc_accordion_direction" style="vertical-align:middle;" src="<?php echo RSCommentsHelper::ImagePath('up.png'); ?>" alt="<?php echo JText::_('COM_RSCOMMENTS_HIDE_FORM'); ?>" height="16" width="16" />
			</span>
			<div class="rscomments_show_form">
		<?php } ?>
			
			<div class="rscContainer">
				<ul class="rscDetails">
					<li>
						<label for="rsc_name" class="<?php echo RSTooltip::tooltipClass(); ?>" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_COMMENT_NAME_DESC')); ?>"><?php echo JText::_('COM_RSCOMMENTS_COMMENT_NAME'); ?></label>
						<input <?php echo $this->disable; ?> type="text" class="rsc_input required" id="rsc_name" name="jform[name]" value="<?php echo $this->user->get('name'); ?>" size="45" />
					</li>
					<li>
						<label for="rsc_email" class="<?php echo RSTooltip::tooltipClass(); ?>" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_COMMENT_EMAIL_DESC')); ?>"><?php echo JText::_('COM_RSCOMMENTS_COMMENT_EMAIL'); ?></label>
						<input <?php echo $this->disable; ?> type="text" class="rsc_input required" id="rsc_email" name="jform[email]" value="<?php echo $this->user->get('email'); ?>" size="45" />
					</li>
				</ul>
				
				<?php if ($this->config->enable_title_field == 1 || $this->config->enable_website_field == 1) { ?>
				<ul class="rscDetails">
					<?php if ($this->config->enable_title_field == 1) { ?>
					<li>
						<label for="rsc_subject" class="<?php echo RSTooltip::tooltipClass(); ?>" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_COMMENT_SUBJECT_DESC')); ?>"><?php echo JText::_('COM_RSCOMMENTS_COMMENT_SUBJECT'); ?></label>
						<input type="text" class="rsc_input" id="rsc_subject" name="jform[subject]" value="" size="45" />
					</li>
					<?php } ?>
					<?php if ($this->config->enable_website_field == 1) { ?>
					<li>
						<label for="rsc_website" class="<?php echo RSTooltip::tooltipClass(); ?>" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_COMMENT_WEBSITE_DESC')); ?>"><?php echo JText::_('COM_RSCOMMENTS_COMMENT_WEBSITE'); ?></label>
						<input type="text" class="rsc_input" id="rsc_website" name="jform[website]" value="" size="45" />
					</li>
					<?php } ?>
				</ul>
				<?php } ?>
				
				<?php $commentLength = (int) $this->config->max_comm_len; ?>
				<div class="rscEditor">
					<div class="rscEditorButtonsContainer">
					<?php $icons = RSCommentsHelper::showIcons($this->permissions); ?>
					<?php if (!empty($icons)) { ?>
						<ul class="rscEditorButtons">
							<?php foreach ($icons as $icon) { ?><li><?php echo $icon; ?></li><?php } ?>
						</ul>
					<?php } ?>
					</div>
					<?php if ($this->config->enable_smiles == 1) { ?>
					<div class="rscEditorEmoticons" id="rsc_emoticons">
						<?php $emoticons = RSCommentsEmoticons::createEmoticons(); ?>
						<?php if (!empty($emoticons)) { ?>
						<ul class="rscEditorButtons">
							<?php foreach ($emoticons as $emoticon) { ?><li><?php echo $emoticon; ?></li><?php } ?>
						</ul>
						<?php } ?>
					</div>
					<?php } ?>
					<span class="rsc_clear">&nbsp;</span>
					<textarea id="rsc_comment" name="jform[comment]" class="required" onkeydown="rsc_comment_cnt('rsc_comment','commentlen','<?php echo $commentLength; ?>');" onkeyup="rsc_comment_cnt('rsc_comment','commentlen','<?php echo $commentLength; ?>');"></textarea>
				</div>
				
				<div class="rscControls">
					<ul class="rscActions">
						<?php if ($this->config->show_subcription_checkbox && !$this->permissions['auto_subscribe_thread']) { ?>
						<li>
							<input type="checkbox" id="rsc_subscribe_thread" class="rsc_chk" name="jform[subscribe_thread]" value="1" /> 
							<label for="rsc_subscribe_thread" class="rscFormLabel <?php echo RSTooltip::tooltipClass(); ?>" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_SUBSCRIBE_DESC')); ?>"><?php echo JText::_('COM_RSCOMMENTS_SUBSCRIBE'); ?></label>
						</li>
						<?php } ?>
					
						<?php if ($this->config->terms) { ?>
						<li>
							<input type="checkbox" id="rsc_terms" class="rsc_chk required" name="jform[rsc_terms]" value="1" /> 
							<a class="rs_modal" rel="{handler : 'iframe'}" href="<?php echo RSCommentsHelper::route('index.php?option=com_rscomments&task=terms&tmpl=component'); ?>">
								<?php echo JText::_('COM_RSCOMMENTS_TERMS'); ?>
							</a>
						</li>
						<?php } ?>
						<li id="rscCounter">
							<?php echo ($this->config->show_counter == 1) ? '<span id="commentlen">'.$commentLength.'</span>&nbsp;'.JText::_('COM_RSCOMMENTS_CHARS_LEFT') : '<span id="commentlen" style="display:none;">'.$commentLength.'</span>'; ?>
						</li>
					</ul>
				</div>
				
				<?php if ($this->config->enable_upload) { ?>
				<div class="rscUpload">
					<iframe src="<?php echo RSCommentsHelper::route('index.php?option=com_rscomments&task=upload&tmpl=component'); ?>" name="rsc_frame" id="rsc_frame" frameborder="0" scrolling="no" width="90%" height="40"></iframe>
				</div>
				<?php } ?>
				
				<?php if (isset($this->permissions['captcha']) && $this->permissions['captcha']) { ?>
				<span class="rsc_clear">&nbsp;</span>
				<div class="rscCaptcha">
					<?php if($this->config->captcha == 0) { ?>
					<img src="<?php echo RSCommentsHelper::route('index.php?option=com_rscomments&task=captcha'); ?>" id="submit_captcha_image" alt="Antispam" height="80" />
						<span class="<?php echo RSTooltip::tooltipClass(); ?>" title="<?php echo RSTooltip::tooltipText(JText::_('COM_RSCOMMENTS_REFRESH_CAPTCHA_DESC')); ?>">
							<a style="border-style: none" href="javascript:void(0)" onclick="return rsc_refresh_captcha('<?php echo $this->root; ?>','<?php echo RSCommentsHelper::route('index.php?option=com_rscomments&task=captcha'); ?>');">
								<img src="<?php echo RSCommentsHelper::ImagePath('refresh.png'); ?>" alt="<?php echo JText::_('COM_RSCOMMENTS_REFRESH_CAPTCHA'); ?>" border="0" onclick="this.blur()" align="top" />
							</a>
						</span> <br />
						<input type="text" name="jform[captcha]" id="submit_captcha" size="40" value="" class="inputbox <?php echo RSTooltip::tooltipClass(); ?> required" title="<?php echo RSTooltip::tooltipText($this->config->captcha_cases ? JText::_('COM_RSCOMMENTS_CAPTCHA_CASE_SENSITIVE') : JText::_('COM_RSCOMMENTS_CAPTCHA_CASE_INSENSITIVE')); ?>" />
					<?php } else {
						require_once(JPATH_SITE.'/components/com_rscomments/helpers/recaptcha/recaptchalib.php');
						echo JReCAPTCHA::getHTML().'<span id="rsc_recaptcha">&nbsp;</span>';
					} ?>
				</div>
				<?php } ?>
				
				<span class="rsc_clear">&nbsp;</span>
				<div id="rscButtons">
					<div id="rsc_loading_form" class="rsloading" style="display:none;">
						<img src="<?php echo RSCommentsHelper::ImagePath('loader.gif'); ?>" alt="" />
					</div>
					
					<?php $upload = (int) $this->config->enable_upload; ?>
					<button type="button" id="rsc_submit" class="rsc_button btn btn-primary" onclick="rsc_validate('<?php echo $upload; ?>' , '<?php echo RSCommentsHelper::route('index.php?option=com_rscomments&task=captcha'); ?>');"><?php echo JText::_('COM_RSCOMMENTS_SEND'); ?></button>
					
					<button type="button" onclick="rsc_reset_form();" id="rsc_reset" class="rsc_button btn"><?php echo JText::_('COM_RSCOMMENTS_RESET'); ?></button>
					<button type="button" id="rsc_cancel" class="rsc_button btn" style="display:none;"  onclick="rsc_cancel_reply();"><?php echo JText::_('COM_RSCOMMENTS_CANCEL'); ?></button>
				</div>
			</div>
		
		<?php if ($this->config->form_accordion) { ?>
			</div>
		</div>
		<?php } ?>
		
		<input type="hidden" id="rsc_id_parent" name="jform[IdParent]" value="0" />
		<input type="hidden" id="rsc_obj_option" name="jform[obj_option]" value="<?php echo $this->option; ?>" />
		<input type="hidden" id="rsc_url" name="jform[url]" value="<?php echo RSCommentsHelper::getUrl(); ?>" />
		<input type="hidden" id="rsc_obj_id" name="jform[obj_id]" value="<?php echo $this->id; ?>" />
		<input type="hidden" id="rsc_IdComment" name="jform[IdComment]" value="" />
		<input type="hidden" id="rsc_override" name="jform[override]" value="<?php echo (int) $this->override; ?>" />
	</form>
</div>
<span class="rsc_clear">&nbsp;</span>
<script type="text/javascript">rsc_initTooltips('rscommentsForm');</script>
<?php if($this->config->enable_smiles == 1) { ?><script type="text/javascript">document.onclick=rsc_check;</script><?php } ?>